# Help new users get started.
#
# Copyright (C) 2007 Mitchell N Charity
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import sys

import qemu


class NewUser:

    def help_new_user_setup(self):
        #XXX replace wiki urls with one of a new /olpc_xo_qemu article.
        print """
Welcome to OLPC laptop emulation on QEMU.

http://wiki.laptop.org/go/Emulating_the_XO and
http://wiki.laptop.org/go/Emulating_the_XO/Quick_Start/Linux
have instructions for gettings started.

"""
        q = qemu.Qemu()
        print "Checking qemu...",
        if not q.have_qemu_running():
            print "failed."
            print """
It doesn't look like you have qemu installed yet.

Please see the instructions.
"""
            sys.exit(1)
        print "ok."
        print "Checking qemu's kqemu...",
#         if not q.have_kqemu_running():
#             print "failed.\n"
#             if not q.clearly_have_kqemu_installed():
#                 print """
# It doesn't look like you have qemu's kqemu installed yet?
# The emulated laptop is painfully slow without it.

# It might be installed, but not available.
# Usually this occurs when modprobe has not been run since you last rebooted.
# """
#             else:
#                 print """
# It looks like kqemu is installed, but not available.
# Usually this occurs when modprobe has not been run since you last rebooted.
# """
#             sys.exit(1)
#         print "ok."
        if not q.clearly_have_kqemu_installed():
            print """
Is kqemu installed?  I can't tell.
The emulated laptop is painfully slow without it.

It might be installed, but not available.
Usually this occurs when modprobe has not been run since you last rebooted.
"""
        else:
            print """
It looks like kqemu is installed.

I don't know how to check if kqemu is working without starting a laptop.
If you see "QEMU acceleration layer not activated" when a laptop is first
started, then kqemu isn't working.
Usually this occurs when modprobe has not been run since you last rebooted.
"""

#It looks like you have qemu and it's working.

        print """

To see avaible builds:
 xo-qemu --report

To download one:
 xo-qemu --get-build STREAM NUMBER PLACE_TO_PUT_IT
 xo-qemu --get-build ship.2 latest builds/
Generally, a "ship" stream is a good place to start.

To make a new laptop:
 xo-qemu --make-laptop somename DISK_IMAGE
DISK_IMAGE is the filename which --get-build prints.

To use the new laptop:
you can turn it on:
 somename/xo on
and later off:
 somename/xo off
and do other things:
 xo-qemu --help

"""
