# Misc utility code.
#
# Copyright (C) 2007 Mitchell N Charity
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import commands
import os
import socket
import sys
import getpass
import random
import re


debug = False

def getoutput_or_exception(command):
    """Run command, returning output, or exception on error"""
    if debug:
        print >>sys.stderr, command
    status,output = commands.getstatusoutput(command)
    if status != 0:
        raise Exception("Command failed: \"%s\" exited with status %d."
                        %(command,status))
    return output

def system_or_exception(command):
    if debug:
        print >>sys.stderr, command
    status = os.system(command)
    if status != 0:
        raise Exception("Command failed(%d): %s"%(status,command))
    return status

def wget_page(url):
    return getoutput_or_exception("wget %s -O -"%(url))

def run_commands_as_root(self,cmds):
    whoami = getoutput_or_exception("whoami")
    if whoami == "root":
        for cmd in cmds:
            system_or_exception(cmd)
    else:
        print "In this directory:\n%s\n"%(os.getcwd())
        print "please run these commands as root,\n%s\n"%("\n".join(cmds))
        print "and then press return."
        getpass.getpass("") # A hack to get Return from the tty.

class Ports:

    def find_unused_ssh_port(self):
        while True:
            port = random.randint(2500,3500)
            if self.is_port_available(port):
                return port

    def find_unused_X_display(self):
        while True:
            port = random.randint(6010,7000)
            if self.is_port_available(port):
                return port-6000

    def is_port_available(self,port):
        s = socket.socket()
        try:
            s.connect(('127.0.0.1', port))
            return False
        except:
            return True
        finally:
            s.close()


class XDisplay:

    def __init__(self,dpy_string):
        m = re.match("([^:]*):(\d+)(?:\.(\d+))?$",dpy_string)
        host,number,screen = m.groups()
        self._host = host
        self._number = int(number)
        if screen:
            raise "screen not implemented"

    def host(self):
        return self._host

    def number(self):
        return self._number

    def port(self):
        return self._number + 6000

    def display(self):
        return "%s:%d"%(self._host, self._number)

    def __str__(self):
        return self.display()

