# QEMU command name and installation.
#
# Copyright (C) 2007 Mitchell N Charity
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import commands
import re

from util import system_or_exception, getoutput_or_exception


class Qemu:

    def _system_MACHTYPE(self):
        return getoutput_or_exception("bash -c 'echo $MACHTYPE'")

    def qemu_program(self):
        cmd = "qemu"
        mach = self._system_MACHTYPE()
        if re.search("x86_64",mach):
            cmd += "-system-x86_64"
        elif re.search("ppc",mach):
            cmd += "-system-ppc"
        return cmd
    
    def have_qemu_running(self):
        cmd = "qemu -soundhw ?"
        status,output = commands.getstatusoutput(cmd)
        return status == 0

    def have_kqemu_running(self):
        #XXX Is there any way to check without an image?
        #cmd = self.qemu_program()+" -kernel-kqemu -soundhw ?"
        #status,output = commands.getstatusoutput(cmd)
        raise Exception("unimplemented")
        return status == 0
    
    def clearly_have_kqemu_installed(self):
        # Red Hat
        status, output = commands.getstatusoutput("/bin/rpm -q kqemu")
        if status == 0:
            return True
        # Debian
        status, output = commands.getstatusoutput("dpkg -l 'kqemu-*'")
        if status == 0:
            return True
        # else
        return False
